#include <pixlib.h>
// à partir du heightmap, crée normal, AO, lightmap, colormap, final

int main()
{
	PIX *hmap = pix_load_png("img/1024/fr.png");

	// NORMAL ------------------------------------------------------------------
	puts("Normal map");
	PIX *nml = pix_copy(hmap);
	//pix_eclaircir(hmp, -10);
	pix_toNormalMap(nml, 128);
	pix_save_bmp(nml, "scripts/couleurs/3D/normal.bmp");

	//AO -----------------------------------------------------------------------
	puts("AO map");
	PIX *AO = pix_create(nml->width, nml->height, 3);
	for(int y=0; y<nml->height; y++){
		for (int x=0; x<nml->width; x++)
		{
			// Ambient Occlusion map is just the blue channel
			//b = getBlue(nml,x,y);
			//setPixel(aoc,x,y, b,b,b);

 			u8* p = nml->pixels + (x+ y * nml->width) * nml->nchannels;
			u8 b = p[2];
 			p = AO->pixels + (x+ y * AO->width) * AO->nchannels;
			p[0] = p[1] = p[2] = b;
		}
	}
	//pix_blur(AO);
	//pix_blur(AO);
	pix_save_bmp(AO, "scripts/couleurs/3D/AO.bmp");

	// LIGHTMAP ----------------------------------------------------------------
	puts("Lightmapping please wait ...");

	int ombrage = 20;
	float angle_rayons = -80.0;
	float hauteur_max_rayons = 350.0;
	float hauteur_max_hmap = 5.0;

	PIX *LM = pix_lightmap(hmap, ombrage, angle_rayons, hauteur_max_rayons, hauteur_max_hmap);
	pix_eclaircir(LM, 90);
	pix_save_bmp(LM, "scripts/couleurs/3D/lightmap.bmp");

	// COLORMAP ----------------------------------------------------------------
	puts("COLORMAP by elevation");
	for(int y=0; y < hmap->height; y++){
		for (int x=0; x < hmap->width; x++)
		{
			u8 r = getRed(hmap,x,y);
			if      (r>150) pix_setPixel(hmap,x,y, r,r,r);
			else if (r>110) pix_setPixel(hmap,x,y, r-20,r-30,0);
			else if (r>90)  pix_setPixel(hmap,x,y, r-10,r-20,0);
			else if (r>50)  pix_setPixel(hmap,x,y, r,r-20,0);
			else if (r>30)  pix_setPixel(hmap,x,y, r-10,r-10,0);
			else if (r>10)  pix_setPixel(hmap,x,y, r-10,r,0);
			else pix_setPixel(hmap,x,y, 0,0,20);
		}
	}
	pix_eclaircir(hmap,15);
	pix_save_bmp(hmap,"scripts/couleurs/3D/colormap.bmp");

	// BAKING ------------------------------------------------------------------
	puts("baking Ambient Occlusion");
	pix_bake(AO, hmap);
	pix_save_bmp(hmap,"scripts/couleurs/3D/colormapAO.bmp");

	puts("baking Lightmap");
	pix_bake(LM, hmap);
	pix_save_png(hmap,"scripts/couleurs/3D/colormapAOLightmap.png");

	pix_destroy(LM);
	pix_destroy(nml);
	pix_destroy(AO);
	pix_destroy(hmap);
	puts("done");
	return 0;
}


