#include <pixlib.h>
// Création d'une texture à partir d'un heightmap
int main()
{
	//PIX *hmap = pix_load_bmp("img/fr-512.bmp");
	PIX *hmap = pix_load_png("img/1024/fr.png");
	PIX* final = pix_blending4(hmap, "img/512/gris.bmp", "img/512/sand.bmp", "img/512/sand.bmp", "img/512/rocher.bmp");

	// filtre vert
	//RGBcolor color = {147,159,144};
	//pix_color_filter(final, &color);

	// met la mer en bleu
	for(int y=0; y<hmap->height; y++){
		for (int x=0; x<hmap->width; x++){
			u8 *p = hmap->pixels + (x+ y * hmap->width) * hmap->nchannels;
			if(p[0] < 1){
				u8 *q = final->pixels + (x+ y * final->width) * final->nchannels;
				q[0] = 12;
				q[1] = 15;
				q[2] = 36;
			}
		}
	}

	pix_destroy(hmap);
	pix_save_bmp(final,"scripts/couleurs/3D/diffuse.bmp");

	puts("baking Ambient Occlusion and Diffuse map");
	PIX* AO = pix_load_bmp("scripts/couleurs/3D/AO.bmp");
	pix_bake(AO, final);
	pix_save_bmp(final,"scripts/couleurs/3D/diffuseAO.bmp");
	pix_destroy(AO);

	puts("baking Lightmap");
	PIX* LM = pix_load_bmp("scripts/couleurs/3D/lightmap.bmp");
	//pix_blur(LM);
	pix_bake(LM, final);
	pix_save_bmp(final,"scripts/couleurs/3D/diffuseAOLightmap.bmp");
	pix_destroy(LM);

	//pix_save_bmp(final,"scripts/couleurs/3D/diffuseAOLightmap.bmp");
	pix_destroy(final);
	return 0;
}

