#include <pixlib.h>

int main()
{
	PIX *img = pix_load_jpg("img/380x520vert.jpg");
	if (!img) return 1;
	
	u8 delta = 20;

	for(int y=0; y<img->height; y++){
		for(int x=0; x<img->width; x++){
			u8* p = img->pixels + (x+ y * img->width) * img->nchannels;			
			// pixel vert? c'est le fond
			if ( (p[1] - p[0]) > delta && (p[1] - p[2]) > delta)
				p[0] = p[1] = p[2] = 255;

			// Le vert se voit un peu sur la peau, réduit ce canal
			else {
				if( (p[0]-delta) > 0) p[0] -= delta; else p[0] = 0;   
				if( (p[1]-delta) > 0) p[1] -= delta; else p[1] = 0;   
			}
		}
	}

	pix_save_png(img, "scripts/couleurs/detourage/detourage.c.png");
	pix_destroy(img);
	return 0;
}

