#include <pixlib.h>
// Écran vert avec correction du canal vert qui rend la peau un peu verte

int main(int n)
{
	PIX *img = pix_load_jpg("img/380x520vert.jpg");
	if (!img) return 1;

	PIX *fond = pix_load_jpg("img/380x520goudes.jpg");
	if (!fond) return 1;
	
	u8 delta = 20;

	int x, y;
	for(y=0; y<img->height; y++)
	{
		for(x=0; x<img->width; x++)
		{
 			u8* p = img->pixels + (x+ y * img->width) * img->nchannels;

			// pixel vert? c'est le fond
			// le remplacer par le pixel équivalent de l'image
			if ( (p[1] - p[0]) > delta && (p[1] - p[2]) > delta)
			{
				//p[0] = p[1] = p[2] = 255;
				u8* i = fond->pixels + (x+ y * img->width) * img->nchannels;
				p[0] = i[0];
				p[1] = i[1];
				p[2] = i[2];
 			}
			// Le vert se voit un peu sur la peau, réduit ce canal
			else {
				if( (p[0]-delta) > 0) p[0] -= delta; else p[0] = 0;   
				if( (p[1]-delta) > 0) p[1] -= delta; else p[1] = 0;   
			}
		}
	}

	//pix_save_jpg(img, "scripts/couleurs/detourage/ecran-vert1.jpg", 100);
	pix_save_png(img, "scripts/couleurs/detourage/ecran-vert.c.png");

	pix_destroy(img);
	return 0;
}

