// Ecrire du texte coloré sur une image avec un font
// idéal pour poser un copyright sur 4000 images tout en buvant le café

#include <pixlib.h>
#include <string.h>

int main()
{
	PIX *img;
	PIXFONT *font;

	img = pix_load_png("img/1.png");
	if (!img) return 1;

	//font = pix_load_font("fonts/georgia32.font");
	font = pix_load_font("fonts/lucida14.font");
	if (!font) return 1;
	//save_font(font, "lucida14.font");

	// écrit le texte à 70 pixels du bord gauche, 50 pixel du haut de l'image
	RGBcolor forecolor = {255,200,255};
	pix_draw_text(img, 70,50, "Accents et arobases\néèà@", forecolor,font);

	// Ecrit du texte en bas à droite, fond bordeau transluicide
	RGBcolor backcolor = {114,29,7};
	pix_draw_text_alpha(img, 3,3, "avec couleur de fond\nainsi que sauts de ligne\\n", forecolor,font, backcolor,1);

	forecolor.b = 0;
	char *text = " ça marche?";
	int x = img->width - (strlen(text)*font->largeur_caractere);
	int y = img->height - font->hauteur_caractere;
	pix_draw_text_alpha(img, x,y, text, forecolor,font, backcolor,0.5f);

	// enregistrer le résultat
	pix_save_png(img, "scripts/couleurs/texte.png");

	pix_destroy(img);
	pix_destroy_font(font);

/*
	PIX *img = pix_load_jpg("img/380x520vert.jpg");
	PIXFONT *font = pix_load_font("fonts/lucida14.font");
	//font2 = loadFont("fonts/lucida7.font");

	// ombrage et texte
	char* text1 = " Dingbao ";

    //void pix_draw_text (PIX *img, int x1, int y1, char *text,RGBcolor forecolor, PIXFONT *font);
	RGBcolor forecolor = {100,100,100};
	pix_draw_text(img, 10,10, text1, forecolor, font);

	RGBcolor couleur = {255,200,255};
	pix_draw_text(img, 8,8, text1, couleur, font);

	char* text = "exemple de drawText();\nAvec saut à la ligne";
	//drawText(img, 30,30, text, 100,100,100, font2);
	//drawText(img, 45,40, text, 92,63,74, font2);

	// texte en bas à droite
	//char* text = "Test 2.0";
	//width  = getWidth(img);
	//height = getHeight(img);
	//charwidth  = getFontWidth(font);
	//charheight = getFontHeight(font);

	int x = img->width - (strlen(text) * font->width);
	int y = img->height - font->taille;
	
	//print("charWidth:",charwidth);
	//print("charHeight:",charheight);
	//print("Len:",strlen(text));
	//print("x,y:",x,y);

	//drawText(img, x,y, text, 255,0,0);
	RGBcolor coul = {255,225,255};
	RGBcolor backcolor = {200,100,50};
	//void pix_draw_text_alpha (PIX *img, int x1, int y1, char *text,
									//RGBcolor forecolor, PIXFONT *font,
									//RGBcolor backcolor, float alpha);
	pix_draw_text_alpha(img, x,y, text, coul, font, backcolor, 0.5);

	pix_save_png(img,"scripts/texte2.png");

	pix_destroy (img);
	pix_destroy_font(font);
	//destroyFont(font2);
*/
	return 0;
}
